function [Z, triples] = ForwardSent(depTree,params,oWe,Wsem)

N = length(depTree.RNum);
Z = zeros(params.h, N);
triples = zeros(3, N);
n=1;

for i=1:N
    
    % pc(2) increases monotonically thoughout the sentence
    pc = depTree.parentChild(i, :);
    if pc(1) <= 0 || pc(2) <=0, continue; end
    if pc(1) > N || pc(2) > N, continue; end
    ix1 = depTree.sNums(pc(1));
    ix2 = depTree.sNums(pc(2)); 
    if ix1==-1 || ix2==-1, continue; end
    
    ri = depTree.RNum(i);
    w1 = oWe(:,ix1);
    w2 = oWe(:,ix2);
    
    vcat = [w1; w2; 1]; % cat
    vlin = Wsem * vcat; % mul
    v = params.f(vlin); % nonlin
    Z(:,n) = v;
    
    triples(:,n) = [ix1,ix2,ri];
    n=n+1;
end

Z = Z(:, 1:n-1); % crop
if nargout > 2
    triples = triples(:, 1:n-1); 
end

end
